Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/MinimalQuantileCriterium.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/MinimalQuantileCriterium.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/MinimalQuantileCriterium.cs	(revision 15064)
@@ -42,18 +42,16 @@
     #region ParameterProperties
     public IFixedValueParameter<DoubleValue> ConfidenceWeightParameter => Parameters[ConfidenceWeightParameterName] as IFixedValueParameter<DoubleValue>;
-
     #endregion
 
     #region Properties
     private double ConfidenceWeight => ConfidenceWeightParameter.Value.Value;
-
     #endregion
 
-    #region HL-Constructors, Serialization and Cloning 
+    #region Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private MinimalQuantileCriterium(bool deserializing) : base(deserializing) { }
-    private MinimalQuantileCriterium(MinimalQuantileCriterium original, Cloner cloner) : base(original, cloner) { }
+    protected MinimalQuantileCriterium(bool deserializing) : base(deserializing) { }
+    protected MinimalQuantileCriterium(MinimalQuantileCriterium original, Cloner cloner) : base(original, cloner) { }
     public MinimalQuantileCriterium() {
-      Parameters.Add(new FixedValueParameter<DoubleValue>(ConfidenceWeightParameterName, "A value between 0 and 1 indicating the focus on exploration (0) or exploitation (1)", new DoubleValue(0.5)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>(ConfidenceWeightParameterName, "A value greater than 0. The larger the value the stronger the emphasis on exploration", new DoubleValue(0.5)));
     }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -66,12 +64,9 @@
       var yhat = model.GetEstimation(vector);
       var s = Math.Sqrt(model.GetVariance(vector)) * ConfidenceWeight;
-      return ExpensiveMaximization ? yhat + s : yhat - s;
+      return (ExpensiveMaximization ? yhat : -yhat) + s;
     }
 
-    public override bool Maximization() {
-      return ExpensiveMaximization;
-    }
 
-    protected override void Initialize() {
+    public override void Initialize() {
       var model = RegressionSolution.Model as IConfidenceRegressionModel;
       if (model == null) throw new ArgumentException("can not calculate EI without confidence measure");
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/NeighbourDistance.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/NeighbourDistance.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/NeighbourDistance.cs	(revision 15064)
@@ -0,0 +1,75 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+// ReSharper disable once CheckNamespace
+namespace HeuristicLab.Algorithms.EGO {
+
+  [StorableClass]
+  [Item("NeighbourDistance", "Exploration by maximizing the distance to the nearest neighbour")]
+  public class NeighbourDistance : InfillCriterionBase {
+
+    private IVantagePointTree<IEnumerable<double>> Points;
+    #region Constructors, Serialization and Cloning 
+    [StorableConstructor]
+    protected NeighbourDistance(bool deserializing) : base(deserializing) { }
+
+    protected NeighbourDistance(NeighbourDistance original, Cloner cloner) : base(original, cloner) {
+    }
+    public NeighbourDistance() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new NeighbourDistance(this, cloner);
+    }
+    #endregion
+
+    public override double Evaluate(RealVector vector) {
+      if (Points == null) Points = CreateTree();
+      IList<IEnumerable<double>> neighbours;
+      IList<double> distances;
+      Points.Search(vector, 1, out neighbours, out distances);
+      return distances[0];
+      //return RegressionSolution.ProblemData.AllIndices.Min(i => DistanceToSample(vector, i));
+    }
+
+    public override void Initialize() {
+      Points = CreateTree();
+    }
+
+    private double DistanceToSample(RealVector vector, int i) {
+      throw new NotImplementedException();
+    }
+
+    private VantagePointTree<IEnumerable<double>> CreateTree() {
+      var data = RegressionSolution.ProblemData.Dataset;
+      var rows = RegressionSolution.ProblemData.AllIndices;
+      var cols = RegressionSolution.ProblemData.AllowedInputVariables;
+      return new VantagePointTree<IEnumerable<double>>(new EuclideanDistance(), rows.Select(r => cols.Select(c => data.GetDoubleValue(c, r)).ToArray()));
+    }
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/PluginExpectedImprovement.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/PluginExpectedImprovement.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/InfillCriteria/PluginExpectedImprovement.cs	(revision 15064)
@@ -20,8 +20,8 @@
 #endregion
 
-using System;
 using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Problems.DataAnalysis;
@@ -32,11 +32,10 @@
   [StorableClass]
   [Item("PluginExpectedImprovement", "Noisy InfillCriterion, Extension of the Expected Improvement by using the minimal prediction on the observed points\n rather than the minimal observed value as described in \n Global optimization based on noisy evaluations: An empirical study of two statistical approaches\r\nEmmanuel Vazqueza, Julien Villemonteixb, Maryan Sidorkiewiczb and Éric Walterc")]
-  public class PluginExpectedImprovement : ExpectedImprovement {
-
+  public class PluginExpectedImprovement : ExpectedImprovementBase {
 
     #region HL-Constructors, Serialization and Cloning 
     [StorableConstructor]
-    private PluginExpectedImprovement(bool deserializing) : base(deserializing) { }
-    private PluginExpectedImprovement(PluginExpectedImprovement original, Cloner cloner) : base(original, cloner) { }
+    protected PluginExpectedImprovement(bool deserializing) : base(deserializing) { }
+    protected PluginExpectedImprovement(PluginExpectedImprovement original, Cloner cloner) : base(original, cloner) { }
     public PluginExpectedImprovement() { }
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -45,9 +44,10 @@
     #endregion
 
-    protected override void Initialize() {
-      if (ExpensiveMaximization) throw new NotImplementedException("PluginExpectedImprovement for maximization not yet implemented");
-      var model = RegressionSolution.Model as IConfidenceRegressionModel;
-      if (model == null) throw new ArgumentException("can not calculate EI without confidence measure");
-      YMin = RegressionSolution.EstimatedTrainingValues.Min();
+    protected override double FindBestFitness(IConfidenceRegressionSolution solution) {
+      return ExpensiveMaximization ? RegressionSolution.EstimatedTrainingValues.Max() : RegressionSolution.EstimatedTrainingValues.Min();
+    }
+
+    protected override double Evaluate(RealVector vector, double estimatedFitness, double estimatedStandardDeviation) {
+      return GetEstimatedImprovement(BestFitness, estimatedFitness, estimatedStandardDeviation, ExploitationWeight, ExpensiveMaximization);
     }
   }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Interfaces/IInfillCriterion.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Interfaces/IInfillCriterion.cs	(revision 15063)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Interfaces/IInfillCriterion.cs	(revision 15064)
@@ -27,7 +27,11 @@
 namespace HeuristicLab.Algorithms.EGO {
   public interface IInfillCriterion : INamedItem {
+
+    IRegressionSolution RegressionSolution { get; set; }
+    bool ExpensiveMaximization { get; set; }
+    RealVectorEncoding Encoding { get; set; }
     double Evaluate(RealVector vector);
-    bool Maximization();
-    void Initialize(IRegressionSolution solution, bool expensiveMaximization, RealVectorEncoding encoding);
+    //bool Maximization();
+    void Initialize();
   }
 }
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/CorrelationAnalyzer.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/CorrelationAnalyzer.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/CorrelationAnalyzer.cs	(revision 15064)
@@ -0,0 +1,94 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Algorithms.EGO {
+  [Item("CorrelationAnalyzer", "Analyzes the correlation between perdictions and actual fitness values")]
+  [StorableClass]
+  public class CorrelationAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    public override bool CanChangeName => true;
+    public bool EnabledByDefault => false;
+
+    public IScopeTreeLookupParameter<RealVector> RealVectorParameter => (IScopeTreeLookupParameter<RealVector>)Parameters["RealVector"];
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter => (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"];
+    public ILookupParameter<IRegressionSolution> ModelParameter => (ILookupParameter<IRegressionSolution>)Parameters["Model"];
+    public ILookupParameter<ResultCollection> ResultsParameter => (ILookupParameter<ResultCollection>)Parameters["Results"];
+
+    private const string PlotName = "Prediction";
+    private const string RowName = "Samples";
+
+    [StorableConstructor]
+    protected CorrelationAnalyzer(bool deserializing) : base(deserializing) { }
+    protected CorrelationAnalyzer(CorrelationAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public CorrelationAnalyzer() {
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("RealVector", "The vector which should be collected."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The quality associated which this vector"));
+      Parameters.Add(new LookupParameter<IRegressionSolution>("Model", "The model of this iteration"));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection to store the results in."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CorrelationAnalyzer(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      var model = ModelParameter.ActualValue;
+      var results = ResultsParameter.ActualValue;
+      var q = QualityParameter.ActualValue.Select(x => x.Value).ToArray();
+      var p = RealVectorParameter.ActualValue.ToArray();
+      if (model == null) return base.Apply();
+      var plot = CreateScatterPlotResult(results);
+      for (var i = 0; i < q.Length; i++) plot.Rows[RowName].Points.Add(new Point2D<double>(model.Model.GetEstimation(p[i]), q[i], p[i]));
+      return base.Apply();
+    }
+
+    private static ScatterPlot CreateScatterPlotResult(ResultCollection results) {
+      ScatterPlot plot;
+      if (!results.ContainsKey(PlotName)) {
+        plot = new ScatterPlot("Fitness-Prediction-Correlation", "The correlation between the predicted and actual fitness values") {
+          VisualProperties = {
+            XAxisTitle = "Predicted Objective Value",
+            YAxisTitle = "True Objective Value"
+          }
+        };
+        results.Add(new Result(PlotName, plot));
+      } else { plot = (ScatterPlot)results[PlotName].Value; }
+      if (!plot.Rows.ContainsKey(RowName)) {
+        plot.Rows.Add(new ScatterPlotDataRow(RowName, RowName, new List<Point2D<double>>()));
+        plot.Rows[RowName].VisualProperties.PointSize = 5;
+      }
+      return plot;
+    }
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/EvaluatedSolutionsAnalyzer.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/EvaluatedSolutionsAnalyzer.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/EvaluatedSolutionsAnalyzer.cs	(revision 15064)
@@ -0,0 +1,107 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.EGO {
+  /// <summary>
+  /// A base class for operators that manipulate real-valued vectors.
+  /// </summary>
+  [Item("EvaluatedSolutionsAnalyzer", "Displays the evaluated Solutions for one or two dimensional problems")]
+  [StorableClass]
+  public class EvaluatedSolutionsAnalyzer : SingleSuccessorOperator, IAnalyzer {
+    public override bool CanChangeName => true;
+    public bool EnabledByDefault => false;
+
+    public IScopeTreeLookupParameter<RealVector> RealVectorParameter => (IScopeTreeLookupParameter<RealVector>)Parameters["RealVector"];
+    public IScopeTreeLookupParameter<DoubleValue> QualityParameter => (IScopeTreeLookupParameter<DoubleValue>)Parameters["Quality"];
+    public ILookupParameter<ResultCollection> ResultsParameter => (ILookupParameter<ResultCollection>)Parameters["Results"];
+    public ILookupParameter<BoolValue> PhaseParameter => (ILookupParameter<BoolValue>)Parameters["InitialPhase"];
+
+    private const string PlotName = "Evaluated Solutions Plot";
+    private const string InitialRowName = "Initial Samples";
+    private const string AdaptiveRowName = "Adaptive Samples";
+
+
+    [StorableConstructor]
+    protected EvaluatedSolutionsAnalyzer(bool deserializing) : base(deserializing) { }
+    protected EvaluatedSolutionsAnalyzer(EvaluatedSolutionsAnalyzer original, Cloner cloner) : base(original, cloner) { }
+    public EvaluatedSolutionsAnalyzer() {
+      Parameters.Add(new ScopeTreeLookupParameter<RealVector>("RealVector", "The vector which should be collected."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>("Quality", "The quality associated which this vector"));
+      Parameters.Add(new LookupParameter<BoolValue>("InitialPhase", "Whether the initial phase has finished"));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection to store the results in."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EvaluatedSolutionsAnalyzer(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      var p = RealVectorParameter.ActualValue.ToArray();
+      if (p.Length == 0 || p[0].Length > 2 || p[0].Length == 0) return base.Apply();
+      var results = ResultsParameter.ActualValue;
+      var q = QualityParameter.ActualValue.Select(x => x.Value).ToArray();
+
+      var plot = CreateScatterPlotResult(results, p[0].Length);
+      var points = plot.Rows[PhaseParameter.ActualValue.Value ? AdaptiveRowName : InitialRowName].Points;
+      if (p[0].Length == 2)
+        for (var i = 0; i < q.Length; i++) points.Add(new Point2D<double>(p[i][0], p[i][1], q[i]));
+      else
+        for (var i = 0; i < q.Length; i++) points.Add(new Point2D<double>(p[i][0], q[i]));
+      return base.Apply();
+
+    }
+
+    private static ScatterPlot CreateScatterPlotResult(ResultCollection results, int dim) {
+      ScatterPlot plot;
+      if (!results.ContainsKey(PlotName)) {
+        plot = new ScatterPlot("Evaluated Solutions", "The solution evaluated so far") {
+          VisualProperties = {
+            XAxisTitle = "First Dimension",
+            YAxisTitle = dim==2?"Second Dimension":"Quality"
+          }
+        };
+        results.Add(new Result(PlotName, plot));
+      } else { plot = (ScatterPlot)results[PlotName].Value; }
+      if (!plot.Rows.ContainsKey(InitialRowName)) {
+        plot.Rows.Add(new ScatterPlotDataRow(InitialRowName, InitialRowName, new List<Point2D<double>>()));
+        plot.Rows[InitialRowName].VisualProperties.PointSize = 5;
+      }
+      if (!plot.Rows.ContainsKey(AdaptiveRowName)) {
+        plot.Rows.Add(new ScatterPlotDataRow(AdaptiveRowName, AdaptiveRowName, new List<Point2D<double>>()));
+        plot.Rows[AdaptiveRowName].VisualProperties.PointSize = 5;
+      }
+      return plot;
+    }
+
+  }
+}
Index: /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/FitnessClusteringAnalyzer.cs
===================================================================
--- /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/FitnessClusteringAnalyzer.cs	(revision 15064)
+++ /branches/EfficientGlobalOptimization/HeuristicLab.Algorithms.EGO/Operators/FitnessClusteringAnalyzer.cs	(revision 15064)
@@ -0,0 +1,132 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Analysis;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.SurrogateProblem;
+
+namespace HeuristicLab.Algorithms.EGO {
+  [Item("FitnessClusteringAnalyzer", "Analyzes the correlation between perdictions and actual fitness values")]
+  [StorableClass]
+  public class FitnessClusteringAnalyzer : SingleSuccessorOperator, IAnalyzer, IStochasticOperator {
+    public override bool CanChangeName => true;
+    public bool EnabledByDefault => false;
+
+    public ILookupParameter<ModifiableDataset> DatasetParameter => (ILookupParameter<ModifiableDataset>)Parameters["Dataset"];
+    public ILookupParameter<ResultCollection> ResultsParameter => (ILookupParameter<ResultCollection>)Parameters["Results"];
+    public IFixedValueParameter<IntValue> KParameter => (IFixedValueParameter<IntValue>)Parameters["K"];
+    public IFixedValueParameter<IntValue> K2Parameter => (IFixedValueParameter<IntValue>)Parameters["K2"];
+    public ILookupParameter<IRandom> RandomParameter => (ILookupParameter<IRandom>)Parameters["Random"];
+
+    private const string SolutionName = "FitnessClustering";
+    private const string PlotName = "FitnessClusterPlot";
+
+    [StorableConstructor]
+    protected FitnessClusteringAnalyzer(bool deserializing) : base(deserializing) { }
+
+    protected FitnessClusteringAnalyzer(FitnessClusteringAnalyzer original, Cloner cloner) : base(original, cloner) { }
+
+    public FitnessClusteringAnalyzer() {
+      Parameters.Add(new LookupParameter<ModifiableDataset>("Dataset"));
+      Parameters.Add(new LookupParameter<ResultCollection>("Results", "The collection to store the results in."));
+      Parameters.Add(new FixedValueParameter<IntValue>("K", "The number of clusters.", new IntValue(3)));
+      Parameters.Add(new FixedValueParameter<IntValue>("K2", "The number of clusters.", new IntValue(3)));
+      Parameters.Add(new LookupParameter<IRandom>("Random"));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new FitnessClusteringAnalyzer(this, cloner);
+    }
+
+    public sealed override IOperation Apply() {
+      var dataset = DatasetParameter.ActualValue;
+      var results = ResultsParameter.ActualValue;
+      var random = RandomParameter.ActualValue;
+      if (dataset.Rows < KParameter.Value.Value || dataset.Rows < 20) return base.Apply();
+
+      var clustering = CreateClustering(dataset, random);
+      if (!results.ContainsKey(SolutionName)) results.Add(new Result(SolutionName, clustering));
+      results[SolutionName].Value = clustering;
+      var plot = CreateTSNEPlot(clustering, dataset, random);
+      if (!results.ContainsKey(PlotName)) results.Add(new Result(PlotName, plot));
+      results[PlotName].Value = plot;
+
+      return base.Apply();
+    }
+
+
+    private ScatterPlot CreateTSNEPlot(KMeansClusteringSolution clustering, ModifiableDataset data, IRandom random) {
+      var clusteredData = (ModifiableDataset)data.Clone();
+      clusteredData.AddVariable("cluster", clustering.ClusterValues.Select(x => (double)x));
+
+      var prob = new RegressionProblem {
+        ProblemData = new RegressionProblemData(clusteredData, new[] { "output" }, "cluster")
+      };
+      var tsne = new TSNEAlgorithm {
+        Perplexity = data.Rows / 3 - 1,
+        Problem = prob
+      };
+      tsne.ClassesParameter.Value.Value = "cluster";
+      var res = EgoUtilities.SyncRunSubAlgorithm(tsne, random.Next());
+      return res.Select(r => r.Value).OfType<ScatterPlot>().First();
+    }
+
+    private KMeansClusteringSolution CreateClustering(ModifiableDataset dataset, IRandom random) {
+      var pd = new ClusteringProblemData(dataset, new[] { "output" });
+      pd.TestPartition.Start = dataset.Rows;
+      pd.TestPartition.End = dataset.Rows;
+      pd.TrainingPartition.Start = 0;
+      pd.TrainingPartition.End = dataset.Rows;
+
+      return ObservationWeightedKMeans.CreateKMeansSolution(pd, GetWeights(dataset), KParameter.Value.Value, 1000, random);
+    }
+    private double[] GetWeights(ModifiableDataset dataset) {
+      var inputMatrix = dataset.ToArray(dataset.VariableNames.Where(x => x.StartsWith("input")), Enumerable.Range(0, dataset.Rows));
+      if (inputMatrix.Cast<double>().Any(x => double.IsNaN(x) || double.IsInfinity(x)))
+        throw new NotSupportedException("k-Means clustering does not support NaN or infinity values in the input dataset.");
+      var indices = Enumerable.Range(0, inputMatrix.GetLength(0)).ToArray();
+      return indices.Select(i =>
+            K2Parameter.Value.Value > 0 ? indices.Where(j => j != i).Select(j =>
+                    1 / Math.Sqrt(EuclideanSquared(inputMatrix, inputMatrix, i, j))
+            ).OrderBy(x => x).Take(K2Parameter.Value.Value).Sum() : 1.0
+         ).ToArray();
+    }
+    private static double EuclideanSquared(double[,] input, double[,] input2, int row1, int row2) {
+      var sum = 0.0;
+      for (var i = 0; i < input.GetLength(1); i++) {
+        var d = input[row1, i] - input2[row2, i];
+        sum += d * d;
+      }
+      return sum;
+    }
+
+  }
+}
